#include<stdio.h>
#include<stdlib.h>
#include<signal.h>
#include<string.h>
#define MAX 10000
#define MAXS 250000

/* Program ocekava soubory vahy.in a vahy.tst v pracovnim
 * adresari. Je potreba jeste provest po skonceni programu
 * diff mezi soubory vahy.out a vahy.tst !! */

int pocet;
int vaha[MAX];
int poradi[MAX];
int dotazu;
int *sipky[MAX];
int dfu[MAX];

int nactidalsi(FILE *soubor) {
  int c,d;
  c=fgetc(soubor);
  if (('0'<=c)&&(c<='9')) {
    d=c-'0';
    while (1) {
      c=fgetc(soubor);
      if (('0'<=c)&&(c<='9')) 
	d=d*10+c-'0'; 
      else 
	break;
      }
    if ((c!=' ')&&(c!=EOF)) ungetc(c,soubor);
    return d;
    }
  while (((c<'0')||(c>'9'))&&(c!=EOF))
    c=fgetc(soubor);
  if (c!=EOF) ungetc(c,soubor);
  return 0;
  }

void nacti(char *fin, char *ftst) {
  FILE *soubor;
  int nacteno,hmotnost,x;
  soubor=fopen(fin,"r");
  fscanf(soubor,"%d",&pocet);
  fclose(soubor);
  soubor=fopen(ftst,"r");
  for (nacteno=0, hmotnost=1; nacteno<pocet; ) {
    x=nactidalsi(soubor);
    if (!x) { 
      hmotnost++; 
      if (hmotnost>nacteno+1) {
        fprintf(stderr,"Internal error: Incorrect format of vahy.tst\n");
	exit(1);
        }
      continue; 
      }
    vaha[x-1]=hmotnost;
    poradi[nacteno++]=x;
    }
  fclose(soubor);
  }

void pridej(int odkud, int kam) {
  odkud--; kam--;
  if (sipky[odkud]==NULL) {
    sipky[odkud]=(int *)malloc(2*sizeof(int));
    if (!sipky[odkud]) { fprintf(stderr,"Internal error: out of memory\n"); exit(1); }
    sipky[odkud][0]=1;
    sipky[odkud][1]=kam;
    }
  else {
    sipky[odkud]=realloc(sipky[odkud],(sipky[odkud][0]+2)*sizeof(int));
    if (!sipky[odkud]) { fprintf(stderr,"Internal error: out of memory\n"); exit(1); }
    sipky[odkud][0]++;
    sipky[odkud][sipky[odkud][0]]=kam;
    }
  }

int cesta(int odkud,int kam) {
  int navstiven[MAX];
  int fronta[MAX];
  int vefronte, zpracovano,i;
  odkud--; kam--;
  for (i=0; i<pocet; i++) navstiven[i]=0;
  navstiven[odkud]=1;
  fronta[0]=odkud; zpracovano=0; vefronte=1;
  for (;zpracovano<vefronte; zpracovano++) {
    if (!sipky[fronta[zpracovano]]) continue;
    for (i=1; i<=sipky[fronta[zpracovano]][0]; i++)
      if (!navstiven[sipky[fronta[zpracovano]][i]]) {
	if (sipky[fronta[zpracovano]][i]==kam) return 1;      
        navstiven[sipky[fronta[zpracovano]][i]]=1;
	fronta[vefronte++]=sipky[fronta[zpracovano]][i];
        }
    }
  return 0;
  }

void povidej(char *flog) {
  int m1,m2,odp,i;
  FILE *log = fopen(flog, "w");
  if (!log) { fprintf(stderr, "Internal error: Unable to create log: %m\n"); exit(1); }  
  signal(SIGPIPE, SIG_IGN);
  dotazu=0;
  for (i=0; i<pocet; i++) { sipky[i]=NULL;
    }
  for(;;) {
    while ((i = getchar()) != '?' && i != EOF);
    if (i == EOF)
      break;
    if (scanf("%d%d", &m1,&m2) != 2) { fprintf(stderr,"Chybna komunikace\n"); exit(1); }
    if ((m1<1)||(m2<1)||(m1>pocet)||(m2>pocet)) { fprintf(stderr,"Cisla minci mimo pripustny rozsah (%d,%d).\n",m1,m2); exit(1); }
    if (m1==m2) { fprintf(stderr,"Cisla minci jsou stejna (%d,%d).\n",m1,m2); exit(1); }
    if (dotazu>MAXS) { fprintf(stderr,"Prilis mnoho volani funkce porovnej.\n"); exit(1); } else dotazu++;
    if (vaha[m1-1]<vaha[m2-1]) odp=-1; else
    if (vaha[m1-1]>vaha[m2-1]) odp=+1; else
	                       odp=0;
    fprintf(log,"Call: %8d %8d  Answer: %2d (%c)\n",m1,m2,odp,odp?(odp>0?'>':'<'):'=');
    switch(odp) {
      case +1:
	if (cesta(m2,m1)) { fprintf(stderr,"Odpoved znama z predchozich volani.\n"); exit(1); }      
	break;
      case 0:
	if (cesta(m1,m2)&&cesta(m2,m1)) { fprintf(stderr,"Odpoved znama z predchozich volani.\n"); exit(1); }      
	break;
      case -1:
	if (cesta(m1,m2)) { fprintf(stderr,"Odpoved znama z predchozich volani.\n"); exit(1); }      
	break;
      } 
    if (odp>=0) pridej(m2,m1);
    if (odp<=0) pridej(m1,m2);
    printf("%d\n",odp);
    fflush(stdout);
    }
  fclose(log);
  }

void verdikt(void) {
  int i;
  for (i=0; i<pocet-1; i++) {
    if (!cesta(poradi[i],poradi[i+1])) { fprintf(stderr,"Neznamy vztah mezi %d a %d.\n",poradi[i],poradi[i+1]); exit(1); };
    if (vaha[poradi[i]]<vaha[poradi[i+1]]) continue;
    if (!cesta(poradi[i],poradi[i+1])) { fprintf(stderr,"Neurcena rovnost mezi %d a %d.\n",poradi[i],poradi[i+1]); exit(1); };
    }
  fprintf(stderr,"OK\n");
  }

void dfu_init(void) {
  int i;
  for (i=0; i<pocet; i++) dfu[i]=-1;
  }

int dfu_repr(int p) {
  if (dfu[p]==-1) return p;
  return dfu[p]=dfu_repr(dfu[p]);
  }	

void dfu_union(int p,int q) {
  dfu[dfu_repr(q)]=dfu_repr(p);
  }

void povidej_same(char *flog) {
  int i,m1,m2,odp;
  FILE *log = fopen(flog, "w");
  if (!log) { fprintf(stderr, "Internal error: Unable to create log: %m\n"); exit(1); }  
  signal(SIGPIPE, SIG_IGN);
  dotazu=0;
  dfu_init();
  for(;;) {
    while ((i = getchar()) != '?' && i != EOF);
    if (i == EOF)
      break;
    if (scanf("%d%d", &m1,&m2) != 2) { fprintf(stderr,"Chybna komunikace\n"); exit(1); }
    if ((m1<1)||(m2<1)||(m1>pocet)||(m2>pocet)) { fprintf(stderr,"Cisla minci mimo pripustny rozsah (%d,%d).\n",m1,m2); exit(1); }
    if (m1==m2) { fprintf(stderr,"Cisla minci jsou stejna (%d,%d).\n",m1,m2); exit(1); }
    if (dotazu>MAXS) { fprintf(stderr,"Prilis mnoho volani funkce porovnej.\n"); exit(1); } else dotazu++;
    odp=0;
    fprintf(log,"Call: %8d %8d  Answer: %2d (%c)\n",m1,m2,odp,odp?(odp>0?'>':'<'):'=');
    if (dfu_repr(m1-1)==dfu_repr(m2-1)) {
      fprintf(stderr,"Odpoved znama z predchozich volani.\n"); exit(1); }
    dfu_union(m1-1,m2-1);
    printf("%d\n",odp);
    fflush(stdout);
    }
  fclose(log);
  if (dotazu!=pocet-1) {
    for (i=1; i<pocet; i++)
      if (dfu_repr(0)!=dfu_repr(i)) {
        fprintf(stderr,"Neurcena rovnost mezi %d a %d.\n",1,i+1);
        break;
        }
    }
  else
    fprintf(stderr,"OK\n");
  }

int cmp_int(const void *pp, const void *qq) {
  const int *p=pp;
  const int *q=qq;
  return *p-*q;
  }

void merge_naslednici(int p,int q) {
  int i,k;	
  if (!sipky[q]) return;
  if (!sipky[p]) { sipky[p]=sipky[q]; sipky[q]=NULL; return; }
  sipky[p]=realloc(sipky[p],(sipky[p][0]+sipky[q][0]+1)*sizeof(int));
  if (!sipky[p]) { fprintf(stderr,"Internal error: out of memory\n"); exit(1); }
  for (i=1; i<=sipky[q][0]; i++) sipky[p][++(sipky[p][0])]=sipky[q][i];
  free(sipky[q]);
  for (i=1; i<=sipky[p][0]; i++) sipky[p][i]=dfu_repr(sipky[p][i]);
  qsort(&(sipky[p][1]),sipky[p][0],sizeof(int),cmp_int);
  for (i=1, k=0; i<=sipky[p][0]; i++)
    if ((i==sipky[p][0])||(sipky[p][i]!=sipky[p][i+1])) {
      sipky[p][++k]=sipky[p][i];
      }
  if (k==sipky[p][0]) return;
  sipky[p]=realloc(sipky[p],(k+1)*sizeof(int));
  if (!sipky[p]) { fprintf(stderr,"Internal error: out of memory\n"); exit(1); }
  sipky[p][0]=k;
  }

void povidej_half(char *flog) {
  int i,m1,m2,odp;
  FILE *log = fopen(flog, "w");
  if (!log) { fprintf(stderr, "Internal error: Unable to create log: %m\n"); exit(1); }  
  signal(SIGPIPE, SIG_IGN);
  dotazu=0;
  for (i=0; i<pocet; i++) sipky[i]=NULL;
  dfu_init();
  for(;;) {
    while ((i = getchar()) != '?' && i != EOF);
    if (i == EOF)
      break;
    if (scanf("%d%d", &m1,&m2) != 2) { fprintf(stderr,"Chybna komunikace\n"); exit(1); }
    if ((m1<1)||(m2<1)||(m1>pocet)||(m2>pocet)) { fprintf(stderr,"Cisla minci mimo pripustny rozsah (%d,%d).\n",m1,m2); exit(1); }
    if (m1==m2) { fprintf(stderr,"Cisla minci jsou stejna (%d,%d).\n",m1,m2); exit(1); }
    if (dotazu>MAXS) { fprintf(stderr,"Prilis mnoho volani funkce porovnej.\n"); exit(1); } else dotazu++;
    if (vaha[m1-1]<vaha[m2-1]) odp=-1; else
    if (vaha[m1-1]>vaha[m2-1]) odp=+1; else
	                       odp=0;
    fprintf(log,"Call: %8d %8d  Answer: %2d (%c)\n",m1,m2,odp,odp?(odp>0?'>':'<'):'=');
    switch(odp) {
      case 0:
        if (dfu_repr(m1-1)==dfu_repr(m2-1)) {
          fprintf(stderr,"Odpoved znama z predchozich volani.\n"); exit(1); }
	  m1=dfu_repr(m1-1);
	  m2=dfu_repr(m2-1);
          dfu_union(m1,m2);
	  merge_naslednici(m1,m2);
	break;
      case +1:
	i=m2; m2=m1; m1=i;
      case -1:
	m1=dfu_repr(m1-1);
	m2=dfu_repr(m2-1);
	/* m1 < m2 */
	if (sipky[m1]) {
          for (i=1; i<=sipky[m1][0]; i++)
            if (m2==dfu_repr(sipky[m1][i])) { fprintf(stderr,"Odpoved znama z predchozich volani.\n"); exit(1); }      
          sipky[m1]=realloc(sipky[m1],(sipky[m1][0]+2)*sizeof(int));
          if (!sipky[m1]) { fprintf(stderr,"Internal error: out of memory\n"); exit(1); }
          sipky[m1][0]++;
          sipky[m1][sipky[m1][0]]=m2;
	  }
	else {
          sipky[m1]=(int *)malloc(2*sizeof(int));
          if (!sipky[m1]) { fprintf(stderr,"Internal error: out of memory\n"); exit(1); }
          sipky[m1][0]=1;
          sipky[m1][1]=m2;
	  }
	break;
      } 
    printf("%d\n",odp);
    fflush(stdout);
    }
  fclose(log);
  for (m1=0; m1<pocet; m1++) if (vaha[m1]==1) break;
  for (i=0; i<pocet; i++)
    if ((vaha[m1]==vaha[i])&&(dfu_repr(m1)!=dfu_repr(i)))	{
      fprintf(stderr,"Neurcena rovnost mezi %d a %d.\n",m1+1,i+1);
      return;
      }
  for (m2=0; m2<pocet; m2++) if (vaha[m2]==2) break;
  for (i=0; i<pocet; i++)
    if ((vaha[m2]==vaha[i])&&(dfu_repr(m2)!=dfu_repr(i)))	{
      fprintf(stderr,"Neurcena rovnost mezi %d a %d.\n",m2+1,i+1);
      return;
      }
  if (dotazu==pocet-2) {
      fprintf(stderr,"Neurceny vztah mezi %d a %d.\n",m1+1,m2+1);
      return;
      }	  
  fprintf(stderr,"OK\n");
  }

int main(int argc, char **argv) {
  /* Usage: vahy_jdg <in> <tst> <log> [std|same|half]
   * std - <in> obsahuje pocet minci a <tst> ocekavny vystup
   * same + vsechny mince maji stejnou hmotnost
   * half + mince jsou pouze dvou ruznych hmotnosti */
  if (argc != 5) { fprintf(stderr, "Internal error: Bad arguments!\n"); return 1; }
  char *fin = argv[1];
  char *ftst = argv[2];
  char *flog = argv[3];
  nacti(fin, ftst);
  if (!strcmp(argv[4],"same")) {
    povidej_same(flog);
    return 0;	  
    }
  if (!strcmp(argv[4],"half")) {
    povidej_half(flog);
    return 0;	  
    }
  povidej(flog);
  verdikt();
  return 0;
}
